#include <stdlib.h>
#include <slmisc.h>
#include "qbookitem.h"

static int dictId;
static int getDictId()
{
  return dictId++;
}

QBookItem::QBookItem (QListView *parent)
  : QListViewItem (parent)
{
  checked = FALSE;
  path = NULL;
  extension = NULL;
  appendix = NULL;
}

QBookItem::~QBookItem ()
{
  if (path)
    free ((void *)path);
  if (extension)
    free ((void *)extension);
  if (appendix)
    free ((void *)appendix);
}

QBookCheckItem::QBookCheckItem (QListView *parent, const QString &name, Type type)
  : QCheckListItem (parent, name, type)
{
}

QBookCheckItem::~QBookCheckItem ()
{
  free ((void *)path);
}

QString QBookCheckItem::key(int , bool ) const
{
  return sortKey;
}

void QBookCheckItem::setSortKey(int id)
{
	did = id;

	sortKey = "F";
	char sortStr[8];
	::sprintf(sortStr, "%4d", did);
	sortKey += QString(sortStr);
}
