#include <qwidget.h>
#include "qhistorylineedit.h"

#define HISTORY_MAX_NUM 100

QHistoryLineEdit::QHistoryLineEdit (QWidget *parent, const char *name)
  : QComboBox (true, parent, name)
{
  setDuplicatesEnabled (false);
  setInsertionPolicy (QComboBox::AtBottom);
  setAutoCompletion (true);
}

void
QHistoryLineEdit::activate()
{
	if(currentText().isEmpty())
		return;

	bool sameExist = FALSE;
	int i;
	QString curStr = currentText();
	for(i=0; i<count(); i++) {
		if(curStr == text(i)) {
			if(i==0)
				return;

			removeItem(i);
			sameExist = TRUE;
			break;
		}
	}

	if(!sameExist) {
		if(i >= HISTORY_MAX_NUM) 
			removeItem(i-1);
	}

	insertItem (curStr, 0);
	setCurrentItem(0);  

}


void
QHistoryLineEdit::keyPressEvent(QKeyEvent* e)
{
	switch(e->key()){
	case Qt::Key_Down:
	case Qt::Key_Up:
		return;
	default:
		break;
	}
	QComboBox::keyPressEvent(e);
}

bool
QHistoryLineEdit::eventFilter(QObject *o, QEvent *e)
{
	if(e->type() == QEvent::FocusIn){
		emit focusChange(true);
	}
	else if(e->type() == QEvent::FocusOut){
		emit focusChange(false);
	}

	if (e->type () == QEvent::KeyPress) {
		QKeyEvent *k = (QKeyEvent *)e;
		switch (k->key ()) {
		case Qt::Key_Return:
			emit returnPressed ();
			return TRUE;
		default:
			break;
		}
	}

	return QComboBox::eventFilter(o,e);
}
