#include <qwidget.h>
#include <qapplication.h>
#include "sllistboxrichtext.h"

SlListBoxRichText::SlListBoxRichText (const QString text=QString::null,
				    const QString ltext=QString::null)
  :SlListBoxText (text)
{
  this->ltext = ltext;
  doc = NULL;
}

SlListBoxRichText::~SlListBoxRichText ()
{
  delete doc;
}

void
SlListBoxRichText::paint ( QPainter *painter)
{
	if (doc && doc->height () != listBox()->font ().pixelSize ()) {
		delete doc;
		doc = NULL;
    }
	int index = -1;
	int index2 = 0;
	int index3 = 0;
	if (selected ()) {
	  if (listBox()->hasFocus()) {
		while ((index = ltext.find ("<img src=", index+1)) >= 0) {
			if (doc) {
				delete doc;
				doc = NULL;
			}
			if( (index2 = ltext.find(">", index)) < index)
				continue;

			index3 = ltext.find("n-font", index);
			if( (index3 > index) && (index3 < index2)) {
				ltext = ltext.replace (index3, strlen ("n-font"),
								   "h-font");
			}
		}
		index = -1;
		while ((index = ltext.find ("<img src=", index+1)) >= 0) {
			if (doc) {
				delete doc;
				doc = NULL;
			}
			if( (index2 = ltext.find(">", index)) < index)
				continue;

			index3 = ltext.find("d-font", index);
			if( (index3 > index) && (index3 < index2))
				ltext = ltext.replace (index3, strlen ("d-font"),
								   "h-font");

		}
	  } else {
		while ((index = ltext.find ("<img src=", index+1)) >= 0) {
			if (doc) {
				delete doc;
				doc = NULL;
			}
			if( (index2 = ltext.find(">", index)) < index)
				continue;

			index3 = ltext.find("n-font", index);
			if( (index3 > index) && (index3 < index2))
				ltext = ltext.replace (index3, strlen ("n-font"),
								   "d-font");

		}
		index = -1;
		while ((index = ltext.find ("<img src=", index+1)) >= 0) {
			if (doc) {
				delete doc;
				doc = NULL;
			}
			if( (index2 = ltext.find(">", index)) < index)
				continue;

			index3 = ltext.find("h-font", index);
			if( (index3 > index) && (index3 < index2))
				ltext = ltext.replace (index3, strlen ("h-font"),
								   "d-font");
		}
	  }

    } else {
		while ((index = ltext.find ("<img src=", index+1)) >= 0) {
			if (doc) {
				delete doc;
				doc = NULL;
			}
			if( (index2 = ltext.find(">", index)) < index)
				continue;

			index3 = ltext.find("h-font", index);
			if( (index3 > index) && (index3 < index2))
				ltext = ltext.replace (index3, strlen ("h-font"),
								   "n-font");
		}
		index = -1;
		while ((index = ltext.find ("<img src=", index+1)) >= 0) {
			if (doc) {
				delete doc;
				doc = NULL;
			}
			if( (index2 = ltext.find(">", index)) < index)
				continue;

			index3 = ltext.find("d-font", index);
			if( (index3 > index) && (index3 < index2))
				ltext = ltext.replace (index3, strlen ("d-font"),
								   "n-font");
		}
    }
	changeImageFont();

	if (!doc) {
		QFont font = listBox()->font ();
		doc = new QSimpleRichText (ltext, font);
		int fsize;
		fsize = font.pixelSize ();

		// XXX enough width to avoid line break...
		doc->setWidth (ltext.length() * fsize * 3);
    }
	QColorGroup g = listBox ()->colorGroup ();
	if (selected ()) {
		g.setColor (QColorGroup::Text, g.highlightedText ());
	}
	else {
		g.setColor (QColorGroup::Text, g.foreground ());
	}

	doc->draw (painter,
			   0, 0,
			   QRect (0, 0, doc->widthUsed (), listBox()->height()),
			   g);

}

void
SlListBoxRichText::changeImageFont()
{

	int pSize = listBox()->font().pixelSize();
	int index, pos1, pos2, pos3;
	index = pos1 = pos2 = pos3 = 0;

	QString sizeStr, sizeStr2;
	sizeStr.setNum(pSize);
	sizeStr2.setNum(pSize);

	while ((pos1 = ltext.find ("<img src=", index)) >= 0) {
		if( (pos2 = ltext.find("width=",pos1)) == -1) {
			index++;
			continue;
		}
		if( (pos3 = ltext.find("height=",pos2)) == -1) {
			index++;
			continue;
		}

		QString wStr = ltext.mid(pos2+6, 2);
		int w = wStr.toInt();
		QString hStr = ltext.mid(pos3+7, 2);
		int h = hStr.toInt();

		index = pos2;
		if( pSize == h )
			continue;

		if(w*2 == h)
			sizeStr2.setNum(pSize/2);
		else
			sizeStr2.setNum(pSize);

		int len = strlen("width=20 height=20");
		if(w<10)
			len--;

		QString repStr = "width=" + sizeStr2 +" height=" + sizeStr;
		ltext = ltext.replace(pos2, len, repStr);
	}

}

