//#ifndef ZTENBOOKMARK_H
//#define ZTENBOOKMARK_H
#include "zten.h"
#include <qvariant.h>
#include <qlayout.h>
#include <qdialog.h>
#include <sllistbox.h>

class QPixmap;

class ZtenBookMark : public QDialog
{
	Q_OBJECT

public:
	ZtenBookMark( QWidget* parent = 0, const char* name = 0,
				  bool modal = FALSE, WFlags fl = 0 );
	~ZtenBookMark();

	void setBookMarkList (QList<BookMark> *list);
	void updateBookMarkList (QList<BookMark> *list);
	QString getCurrentEntry();

public slots:
	void slotOpenBookMark();
	void slotDeleteBookMark();

	void accept();
	void reject();

private:
	void updateButtons();

	QList <BookMark> _markList;

    QPushButton* OpenButton;
    QPushButton* DeleteButton;
    SlListBox* BookMarkList;

protected:
    QVBoxLayout* ZtenBookMarkBaseLayout;
    QHBoxLayout* Layout1;

};

//#endif // ZTENBOOKMARK_H
