#ifndef ZTENCANDIDATE_H
#define ZTENCANDIDATE_H

#include "sllistboxrichtext.h"
#include <qtextcodec.h>
#include <qlist.h>
#include <qlineedit.h>
#include <qarray.h>
#include <eb.h>

#include <qlayout.h>
#include <qvariant.h>
#include <qdialog.h>
#include <sllistbox.h>

#define MAX_CANDIDATE 1000

class ZtenCandidate : public QDialog
{
  Q_OBJECT
public:
  ZtenCandidate (EB_Book *book,
		 EB_Position pos,
		 int index,
		 QWidget* parent = 0, const char *name = 0, bool modal = TRUE,
		 WFlags fl = 0);
  ~ZtenCandidate ();
  QTextCodec *codec;
  void addCandidate (QString, EB_Position);
  void setGaijiCode (QString);
private:
    SlListBox* Candidates;
    QPushButton* SelectButton;
    QPushButton* BackButton;

    QVBoxLayout* ZtenCandidateBaseLayout;
    QHBoxLayout* Layout4;

  EB_Hookset candidate_hookset;
  EB_Book *book;
  EB_Hookset text_hookset;

  QArray<EB_Position> pos_list;
  QArray<EB_Position> history;
  QList<QString> candidate_list;

  QList<QString> ltext_list;
  QList<QString> gaiji_list;
  QString code;

  int history_current;
  int index;

  void setContent (EB_Position pos);
  void setContentNoHistory (EB_Position pos);
  void setGaijiList(QString);

private slots:
  void jump (SlListBoxItem *);
  void back ();
  void select ();
protected slots:
  virtual void accept ();
signals:
  void candidateDecided (int index, QString text, QString label, bool isGaiji);
};

#endif // ZTENCANDIDATE_H
