#ifndef ZTENSETDICT_H
#define ZTENSETDICT_H
#include "zten.h"
#include "ztensetdictbase.h"
#include "qbookitem.h"

class QAction;
class QPixmap;
class QVBoxLayout; 
class QHBoxLayout; 
class QGridLayout; 
class QListView;
class QCheckListItem;

class ZtenSetDict : public ZtenSetDictBase
{
  Q_OBJECT
public:
  ZtenSetDict( QWidget* parent = 0, const char* name = 0, bool modal = FALSE, WFlags fl = 0 );
  ~ZtenSetDict();

  void addBook(QBookItem *item);
  void clearBooks();

  void setDictList (QList<DictInfo> *list);
  void updateDictList (QList<DictInfo> *list);
  void checkAvailableDict (QList<DictInfo> *list);

  bool isListChanged() { return listChanged; }

public slots:
  void selectBook();
  void listUp();
  void listDown();
  void setExtension();
  void deleteBook();
  void accept();
  void reject();

private:
  bool listChanged;

};

#endif // ZTENBOOK_H
